Subject: Re: linux-next: build failure after merge of the mm tree

From: Uros Bizjak <[email-masked]>
Date: Fri, 16 Aug 2024 08:45:56 +0200

On Fri, Aug 16, 2024 at 3:29 AM Stephen Rothwell <[email-masked]> wrote:
>
> Hi Uros,
>
> On Thu, 15 Aug 2024 09:42:51 +0200 Uros Bizjak <[email-masked]> wrote:
> >
> > > Caused by commit
> > >
> > >   8e53757638ec ("err.h: add ERR_PTR_PCPU(), PTR_ERR_PCPU() and IS_ERR_PCPU() functions")
> > >
> > > Does include/linux/err.h really need to include asm/percpu.h?  __percpu is
> > > defined in compiler_types.h which is included in every c code compile.
> >
> > Currently it is not needed, but with the proposed patch [1]
> >
> > [1] https://lore.kernel.org/lkml/[email-masked]/
> >
> > that repurposes __percpu to also include percpu named address
> > qualifier, it will be needed, because per_cpu_qual will be defined in
> > include/asm-generic/percpu.h.
>
> How about putting these new functions in a new header file
> (err_percpu.h?) and including that where needed?  Are there going to be
> many places that need these new functions?

Actually, there are only 4 files that need these functions, but some
of them mix generic and percpu versions. I
have to rethink this a bit (I considered asm/percpu.h as a "light"
header that can be included without much problem for every target, but
for powerpc, this is apparently not a case due to paca.h include) and
will definitely consider your suggestion.

Thanks,
Uros.